"use strict";
/*!
 * Mumsys
 * for MUMSYS Library for Multi User Management System (MUMSYS)
 *
 * @license LGPL Version 3 http://www.gnu.org/licenses/lgpl-3.0.txt
 * @copyright Copyright (c) 2017 by Florian Blasel for FloWorks Company
 * @author Florian Blasel <flobee.code@gmail.com>
 *
 * @category    Mumsys
 * @package     Js
 */
class Mumsys{static getVersion(){return'3.1.1';}
constructor(){}
static checkJsonRpcResponce(response){if(!(response instanceof Object)){var message='Invalid json rpc resopnse';throw new Mumsys_Exception(message);}}}
class Mumsys_Exception extends Error{static get ERRCODE_DEFAULT(){return 1;}
static getVersion(){return'3.0.0';}
constructor(message,code=0){super(message);this.name=this.constructor.name;this.code=code;if(typeof Error.captureStackTrace==='function'){Error.captureStackTrace(this,this.constructor);}else{this.stack=(new Error(message)).stack;}}}
class Mumsys_File_Item_Exception
extends Mumsys_Exception{static getVersion(){return'3.0.0';}};class Mumsys_File_Item_Default{static getVersion(){return'3.0.1';}
constructor(params){this.path=params.path;this.name=params.filename;this.size=params.filesize;this.type=params.filetype;this.mimetype=params.mimetype;}
get location(){if(this.path!==undefined&&this.name!==undefined){return this.path+'/'+this.name;}
var message='No path or file was set to get the location';throw new Mumsys_File_Item_Exception(message,Mumsys_Exception.ERRCODE_DEFAULT);}}
class Mumsys_Generic_Exception
extends Mumsys_Exception{static getVersion(){return'3.0.0';}};class Mumsys_Generic_Item_Exception
extends Mumsys_Generic_Exception{static getVersion(){return'3.0.0';}};class Mumsys_Generic_Manager_Exception
extends Mumsys_Generic_Exception{static getVersion(){return'3.0.0';}};class Mumsys_Generic_Item_Default{static getVersion(){return'3.1.1';}
constructor(params){this.__itemProps={};this.__m=false;if(params instanceof Object){this.__itemProps=params;if(undefined!==params.id){this.set('id',params.id);}}else{var message='Invalid parameters';throw new Mumsys_Generic_Item_Exception(message);}
this.setModified(false);}
get(key,defVal){if(this.__itemProps[key]===undefined){return defVal;}else{return this.__itemProps[key];}}
set(key,val){var v=this.get(key);if(JSON.stringify(v)===JSON.stringify(val)){return;}
if(key==='id'){if((this.__itemProps[key]=this._checkId(this.get("id"),val))===null){this.setModified(true);}else{this.setModified(false);}}else{this.__itemProps[key]=val;this.setModified(true);}}
getProperties(){return this.__itemProps;}
isModified(){return this.__m;}
setModified(flag){var _flag;if(flag===undefined){_flag=true;}else{_flag=Boolean(flag);}
this.__m=_flag;}
_checkId(oldID,newID){if(newID===undefined||oldID===undefined){var message='Invalid ID given: old: "'+oldID+'", new: "'+newID+'"';throw new Mumsys_Generic_Item_Exception(message);}
if(newID!==null&&oldID!==null&&oldID!==newID){var message='New item ID "'+newID+'" differs from old ID "'+oldID+'"';throw new Mumsys_Generic_Item_Exception(message);}
return newID;}}
class Mumsys_Generic_Manager_Default{static getVersion(){return'3.1.1';}
constructor(url=false){this.__url='jsonrpc.php';if(url){this.__url=url;}
this.__itemList=[];this.__flags={"isLoaded":false};this.__map={};}
createItem(props){if(props instanceof Object){return new Mumsys_Generic_Item_Default(props);}else{var message='Invalid properties';throw new Mumsys_Generic_Manager_Exception(message);}}
addItem(item){if(item instanceof Mumsys_Generic_Item_Default){var id=item.get('id');if(id!==undefined&&this.__map[id]!==undefined){var message='"id" ('+id+') is unique and already exists';throw new Mumsys_Generic_Manager_Exception(message);}
if(id!==undefined){this.__map[id]=this.__itemList.length;}
this.__itemList.push(item);}
else{throw new Mumsys_Generic_Manager_Exception('Invalid item');}}
removeItem(id){var _tmp=[];var _tmpmap={};if(this.__map[id]!==undefined){this.__itemList.splice(this.__map[id],1);delete this.__map[id];return;}
for(var i=0;i<this.__itemList.length;i++){var itemID=this.__itemList[i].get('id');if(itemID!==id){_tmp.push(this.__itemList[i]);_tmpmap[itemID]=i;}}
this.__itemList=_tmp;this.__map=_tmpmap;}
getItems(){return this.__itemList;}
getItem(key,value,defreturn){if(key==='idx'){if(value===-1){var k;if((this.__itemList.length-1)<0){k=0;}else{k=this.__itemList.length-1;}
return this.__itemList[k];}
else{return this.__itemList[value];}
return this.__itemList[value];}
if(key==='id'&&this.__map[key]!==undefined){return this.__itemList[this.__map[key]];}
for(var i=0;i<this.__itemList.length;i++){if(this.__itemList[i].get(key)===value){return this.__itemList[i];}}
return defreturn;}
clear(){this.__itemList=[];this.__map={};}
isLoaded(){return this.__flags.isLoaded;}
loadItems(data,requestParams=false){var _reParams;var _this=this;this.__flags.isLoaded=false;var defaultParams={url:this.__url,async:true,type:'GET',contentType:'application/json',dataType:'json',success:function(obj){Mumsys.checkJsonRpcResponce(obj);for(var i=0;i<obj.result.list.length;i++){_this.addItem(_this.createItem(obj.result.list[i]));}
_this.__flags.isLoaded=true;},error:function(obj){Mumsys.checkJsonRpcResponce(obj);}};_reParams=this._buildParams(defaultParams,data,requestParams);jQuery.ajax(_reParams).done(function(obj){Mumsys.checkJsonRpcResponce(obj);});}
saveItem(item,params,requestOptions=false){if(params.item!==undefined){var message='params.item property already defined';throw new Mumsys_Generic_Manager_Exception(message);}
if(item.isModified()){params.item=item.getProperties();var defaultParams={url:this.__url,type:"POST",fail:function(obj,textStatus,errorThrown){console.log("fail textStatus",textStatus);console.log("fail errorThrown",errorThrown);Mumsys.checkJsonRpcResponce(jQuery.parseJSON(obj.responseText));}};var reqParams=this._buildParams(defaultParams,params,requestOptions);jQuery.ajax(reqParams).done(function(obj){Mumsys.checkJsonRpcResponce(obj);if(obj.result.item.id!==undefined){item.set('id',obj.result.item.id);}});item.setModified(false);}
return item;}
_buildParams(defaultParams,dataParams,requestParams){var obj={};if(requestParams){for(var keyA in defaultParams){if(requestParams[keyA]===undefined){obj[keyA]=defaultParams[keyA];}}
for(var keyB in requestParams){if(requestParams[keyB]!==null){obj[keyB]=requestParams[keyB];}}}
else{obj=defaultParams;}
obj.data=dataParams;return obj;}}
function Mumsys_Generic_Item(params){this.__itemProps={};this.__m=false;if(params instanceof Object){this.__itemProps=params;if(undefined!==params.id){this.set('id',params.id);}}else{var message='Invalid parameters';throw new Error(message);}
this.setModified(false);};Mumsys_Generic_Item.prototype.getVersion=function(){return'3.0.0';};Mumsys_Generic_Item.prototype.get=function(key,defVal){if(this.__itemProps[key]===undefined){return defVal;}else{return this.__itemProps[key];}};Mumsys_Generic_Item.prototype.set=function(key,val){var v=this.get(key);if(JSON.stringify(v)===JSON.stringify(val)){return;}
if(key==='id'){if((this.__itemProps[key]=this._checkId(this.get("id"),val))===null){this.setModified(true);}else{this.setModified(false);}}else{this.__itemProps[key]=val;this.setModified(true);}};Mumsys_Generic_Item.prototype.getProperties=function(){return this.__itemProps;};Mumsys_Generic_Item.prototype.isModified=function(){return this.__m;};Mumsys_Generic_Item.prototype.setModified=function(flag){if(flag===undefined){var flag=true;}else{var flag=Boolean(flag);}
this.__m=flag;};Mumsys_Generic_Item.prototype._checkId=function(oldID,newID){if(newID===undefined||oldID===undefined){var message='Invalid ID given: old: "'+oldID+'", new: "'+newID+'"';throw new Mumsys_Generic_Item_Exception(message);}
if(newID!==null&&oldID!==null&&oldID!==newID){var message='New item ID "'+newID+'" differs from old ID "'+oldID+'"';throw new Mumsys_Generic_Item_Exception(message);}
return newID;};function Mumsys_Generic_Manager(url=false){this.__url='jsonrpc.php';if(url){this.__url=url;}
this.__itemList=[];this.__flags={"isLoaded":false};this.__map={};}
Mumsys_Generic_Manager.prototype.getVersion=function(){return'3.0.0';};Mumsys_Generic_Manager.prototype.createItem=function(props){if(props instanceof Object){return new Mumsys_Generic_Item(props);}else{var message='Invalid properties';throw new Error(message);}};Mumsys_Generic_Manager.prototype.addItem=function(item){if(item instanceof Mumsys_Generic_Item){var id=item.get('id');if(id!==undefined&&this.__map[id]!==undefined){var message='"id" ('+id+') is unique and already exists';throw new Error(message);}
if(id!==undefined){this.__map[id]=this.__itemList.length;}
this.__itemList.push(item);}else{throw new Error('Invalid item');}};Mumsys_Generic_Manager.prototype.removeItem=function(id){var _tmp=[];var _tmpmap={};for(var i=0;i<this.__itemList.length;i++){var itemID=this.__itemList[i].get('id');if(itemID!==id){_tmp.push(this.__itemList[i]);_tmpmap[itemID]=i;}}
this.__itemList=_tmp;this.__map=_tmpmap;};Mumsys_Generic_Manager.prototype.getItems=function(){return this.__itemList;};Mumsys_Generic_Manager.prototype.getItem=function(key,value,defreturn){if(key==='idx'){if(value===-1){if((this.__itemList.length-1)<0){var k=0;}else{var k=this.__itemList.length-1;}
return this.__itemList[k];}else{return this.__itemList[value];}
return this.__itemList[value];}
if(key==='id'&&this.__map[key]!==undefined){return this.__itemList[this.__map[key]];}
for(var i=0;i<this.__itemList.length;i++){if(this.__itemList[i].get(key)===value){return this.__itemList[i];}}
return defreturn;};Mumsys_Generic_Manager.prototype.clear=function(){this.__itemList=[];this.__map={};};Mumsys_Generic_Manager.prototype.isLoaded=function(){return this.__flags.isLoaded;};Mumsys_Generic_Manager.prototype.loadItems=function(data,requestParams=false){var _reParams;var _this=this;this.__flags.isLoaded=false;var defaultParams={url:this.__url,async:true,type:'GET',contentType:'application/json',dataType:'json',success:function(obj){Mumsys.checkJsonRpcResponce(obj);for(var i=0;i<obj.result.list.length;i++){_this.addItem(_this.createItem(obj.result.list[i]));}
_this.__flags.isLoaded=true;},error:function(obj){Mumsys.checkJsonRpcResponce(obj);}};_reParams=this._buildParams(defaultParams,data,requestParams);jQuery.ajax(_reParams).done(function(obj){Mumsys.checkJsonRpcResponce(obj);});};Mumsys_Generic_Manager.prototype.saveItem=function(item,params,requestParams=false){if(params.item!==undefined){var message='params.item property already defined';throw new Error(message);}
if(item.isModified()){params.item=item.getProperties();var defaultParams={url:this.__url,type:'POST',fail:function(obj,textStatus,errorThrown){console.log("fail textStatus",textStatus);console.log("fail errorThrown",errorThrown);Mumsys.checkJsonRpcResponce(jQuery.parseJSON(obj.responseText));}};var reqParams=this._buildParams(defaultParams,params,requestParams);jQuery.ajax(reqParams).done(function(obj){Mumsys.checkJsonRpcResponce(obj);if(obj.result.item.id!==undefined){item.set('id',obj.result.item.id);}});item.setModified(false);}
return item;};Mumsys_Generic_Manager.prototype._buildParams=function(defaultParams,dataParams,requestParams){var obj={};if(requestParams){for(var keyA in defaultParams){if(requestParams[keyA]===undefined){obj[keyA]=defaultParams[keyA];}}
for(var keyB in requestParams){if(requestParams[keyB]!==null){obj[keyB]=requestParams[keyB];}}}else{obj=defaultParams;}
obj.data=dataParams;return obj;};